#!/usr/bin/env python

import ut
import v
import line
import vecs
import img

def new(p, vs):
	# vs: vecs

	e = ut.Empty()
	e.typ = 'ax'
	e.p = p
	e.vs = vs

	l2g = lambda p: v.op2( '+', vs.tr('l2g', p), e.p )
	g2l = lambda p: vs.tr( 'g2l', v.op2('-', p, e.p) )
	e.tr_p = lambda d, p: { 'l2g': l2g, 'g2l': g2l }.get(d, l2g)(p)
	e.tr_v = lambda d, v: vs.tr(d, v)
	e.tr_line = lambda d, l: line.new( e.tr_p(d, l.p), e.tr_v(d, l.v) )

	def tr(d, targ, typ='p'):
		dic = {
			'p': e.tr_p,
			'v': e.tr_v,
			'line': e.tr_line,
		}
		f = dic.get( ut.get_typ(targ, typ), e.tr_p )
		return f(d, targ)
	e.tr = tr

	def compo(ax_outside):
		# o.p + o.vs x (i.p + i.vs x p)
		# = (o.p + o.vs x i.p) + o.vs x i.vs x p
		d = 'l2g'
		vs_ = vecs.new( map( lambda v: ax_outside.tr(d, v, typ='v'), vs.v3 ) )
		p_ = ax_outside.tr(d, p)
		return new(p_, vs_)
	e.compo = compo

	def rev():
		# P = a.p + a.vs * p
		# p = rev(a.vs) * (P - a.p)
		# = { rev(a.vs) * (-a.p) } + rev(a.vs) * P
		vs_ = vs.rev()
		if not vs_:
			return []
		p_ = vs_.tr( 'l2g', v.nega(p) )
		return new(p_, vs_)
	e.rev = rev

	return e

one = new( [0,0,0], vecs.one )
slide = lambda sld: new(sld, vecs.one)
slide_x = lambda x: slide( [x,0,0] )
slide_y = lambda y: slide( [0,y,0] )
slide_z = lambda z: slide( [0,0,z] )
zoom = lambda zm3: new( [0,0,0], vecs.one.zoom(zm3) )
zoom_all = lambda zm: zoom( [zm,zm,zm] )
zoom_x = lambda zm: zoom( [zm,1,1] )
zoom_y = lambda zm: zoom( [1,zm,1] )
zoom_z = lambda zm: zoom( [1,1,zm] )
rot_y = lambda deg: new( [0,0,0], vecs.rot_y(deg) )
rot = lambda l, deg: ( lambda ax: ax.rev().compo( rot_y(deg) ).compo(ax) )( new_line(l) )
rot_x = lambda deg: rot(line.x1, deg)
rot_z = lambda deg: rot(line.z1, deg)

wh_map = lambda w, h: slide( [-w*0.5,-h*0.5,0] ).compo( zoom_all(1.0/w) ).compo( rot_x(180) )

def fn_map(fn):
	(w, h) = img.imgs.wh(fn)
	return wh_map(w, h)

new_line = lambda l: new( l.p, vecs.by_fix_ref('y', l.v, 'z', v.z1) )

# EOF
