#!/usr/bin/env python

import sys
import math
import ut
import mt
import v
import line
import ax
import cylx
import fcx
import lstx
import img
import way
import wf

if __name__ == "__main__":

	copen = 'copen-090419.jpg'
	beat = 'beat.jpg'

	data = [ {
		'kind': 'square',
		'l2g': [ ax.zoom_all(50) ],
	},{
		'kind': 'ball',
		'l2g': [ ax.zoom_all(20) ],
	} ]

	(w, h) = ( ut.arg_i('w', 640) , ut.arg_i('h', 480) )
	div = ut.arg_i('div', 1)
	(w, h) = map( lambda v: v / div, (w, h) )
	zm = div

	w_deg = ut.arg_f('w_deg', 30.0)

	dz = 1.0 / math.tan( 0.5 * mt.deg_to_rad(w_deg) )
	sc_sz = (w, h, dz*w)

	cnt = ut.new_cnt_wait('frm')
	name = ut.arg_s('name', '../rt_out/test/rt')

	ut.mkdir_if_not(name)
	codec = ut.arg_s('codec', 'H264')
	video = img.new_video(codec, name+'.mp4', cnt.fps, w, h, zm)

	eye_f = way.liss_eye()
	wh2eye = lstx.opt( [ ax.wh_map(w, h), fcx.new(dz), ax.zoom_z(-1), ax.rot_x(90) ] )

	n = cnt.n
	while cnt.up():
		i = cnt.cur()

		eye2g = ax.new_line( eye_f( cnt.cur_sec() ) )

		wf.draw(data, eye2g, wh2eye, sc_sz, video)

		video.add_img()
		fn = ( name if n == 1 else name+'0000{}'.format(i)[-5:] ) + '.jpg'
		video.write(fn)

		wsec = max( cnt.wait_sec(), 0 ) if n > 1 else -1
		video.show_zm('', wsec)
		video.clear()
	video.fin()
# EOF
