#!/usr/bin/env python

import math
import ut
import mt
import v

def new(v3):
	# v3: [ v.x1, v.y1, v.z1 ]

	e = ut.Empty()
	e.typ = 'vecs'
	e.v3 = v3
	l2g = lambda v_: v.lst_add( map( lambda (a, e): v.op1('*', a, e), zip(v3, v_) ) )
	g2l = lambda v_: map( lambda a: v.dot_product_len(v_, a), v3 )
	e.tr = lambda d, v: { 'l2g': l2g, 'g2l': g2l }.get(d, l2g)(v)

	e.rev = lambda : new( mt.v3_rev(v3) )

	e.zoom = lambda zm3: new( map( lambda (v_, zm): v.op1('*', v_, zm), zip(v3, zm3) ) )
	e.zoom_all = lambda zm: e.zoom( [zm,zm,zm] )
	e.zoom_x = lambda zm: e.zoom( [zm,1,1] )
	e.zoom_y = lambda zm: e.zoom( [1,zm,1] )
	e.zoom_z = lambda zm: e.zoom( [1,1,zm] )

	return e

one = new( [v.x1, v.y1, v.z1] )

def by_fix_ref(fix_nm, fix, ref_nm, ref):
	fix_i = 'xyz'.index(fix_nm)
	ref_i = 'xyz'.index(ref_nm)

	lst = [0,1,2]
	lst.remove(fix_i)
	lst.remove(ref_i)
	i = lst[0]

	v3 = [ [],[],[] ]
	v3[fix_i] = fix

	if fix == ref:
		ref = ( lambda (x, y, z): (-y, x, z) )( ref ) if ref != v.z1 else v.x1

	(a, b) = (fix, ref) if (fix_i + 1) % 3 == ref_i else (ref, fix)
	v3[i] = c = v.cross_product_unit(a, b)

	(a, b) = (fix, c) if (fix_i + 1) % 3 == i else (c, fix)
	v3[ref_i] = v.cross_product_unit(a, b)
	
	return new(v3)

def rot_y(deg):
	rad = mt.deg_to_rad(deg)
	s = math.sin(rad)
	c = math.cos(rad)

	(x, y, z) = one.v3
	(xx, xy, xz) = x
	(yx, yy, yz) = y
	(zx, zy, zz) = z

	zz = xx = c
	xz = -s
	zx = s

	x = (xx, xy, xz)
	y = (yx, yy, yz)
	z = (zx, zy, zz)
	v3 = (x, y, z)

	return new(v3)
# EOF
